Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/src/main.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/src/main.cpp	(revision 111)
@@ -15,140 +15,142 @@
   err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
   err (_("list_params is :\n"));
-  err (_(" * size_general_data                                                                    (uint32_t         )\n"));
-  err (_(" * size_special_data                                                                    (uint32_t         )\n"));
-//morpheo::behavioural::custom::custom_information_t (*get_custom_information) (void),
-    
-  err (_(" * nb_thread                                                                            (uint32_t         )\n"));
-  err (_(" * size_ifetch_queue                       [nb_thread]                                  (uint32_t         )\n"));
-  err (_(" * nb_inst_fetch                           [nb_thread]                                  (uint32_t         )\n"));
-//err (_(" * implement_group                         [nb_thread][NB_GROUP]                        (bool             )\n"));
-  err (_(" * ras_size_queue                          [nb_thread]                                  (uint32_t         )\n"));
-  err (_(" * upt_size_queue                          [nb_thread]                                  (uint32_t         )\n"));
-  err (_(" * ufpt_size_queue                         [nb_thread]                                  (uint32_t         )\n"));
-
-  err (_(" * nb_decod_bloc                                                                        (uint32_t         )\n"));
-  err (_(" * size_decod_queue                        [nb_decod_bloc]                              (uint32_t         )\n"));
-  err (_(" * nb_inst_decod                           [nb_decod_bloc]                              (uint32_t         )\n"));
-  err (_(" * nb_context_select                       [nb_decod_bloc]                              (uint32_t         )\n"));
-  err (_(" * context_select_priority                 [nb_decod_bloc]                              (Tpriority_t      )\n"));
-  err (_(" * context_select_load_balancing           [nb_decod_bloc]                              (Tload_balancing_t)\n"));
-
-  err (_(" * nb_rename_bloc                                                                       (uint32_t         )\n"));
-  err (_(" * nb_inst_insert                          [nb_rename_bloc]                             (uint32_t         )\n"));
-  err (_(" * nb_inst_retire                          [nb_rename_bloc]                             (uint32_t         )\n"));
-  err (_(" * rename_select_priority                  [nb_rename_bloc]                             (Tpriority_t      )\n"));
-  err (_(" * rename_select_load_balancing            [nb_rename_bloc]                             (Tload_balancing_t)\n"));
-  err (_(" * rename_select_nb_front_end_select       [nb_rename_bloc]                             (uint32_t         )\n"));
-  err (_(" * nb_general_register                     [nb_rename_bloc]                             (uint32_t         )\n"));
-  err (_(" * nb_special_register                     [nb_rename_bloc]                             (uint32_t         )\n"));
-  err (_(" * nb_reg_free                             [nb_rename_bloc]                             (uint32_t         )\n"));
-  err (_(" * nb_rename_unit_bank                     [nb_rename_bloc]                             (uint32_t         )\n"));
-  err (_(" * size_read_counter                       [nb_rename_bloc]                             (uint32_t         )\n"));
-
-  err (_(" * nb_read_bloc                                                                         (uint32_t         )\n"));
-  err (_(" * size_read_queue                         [nb_read_bloc]                               (uint32_t         )\n"));
-  err (_(" * size_reservation_station                [nb_read_bloc]                               (uint32_t         )\n"));
-  err (_(" * nb_inst_retire_reservation_station      [nb_read_bloc]                               (uint32_t         )\n"));
-
-  err (_(" * nb_write_bloc                                                                        (uint32_t         )\n"));
-  err (_(" * size_write_queue                        [nb_write_bloc]                              (uint32_t         )\n"));
-  err (_(" * size_execute_queue                      [nb_write_bloc]                              (uint32_t         )\n"));
-  err (_(" * nb_bypass_write                         [nb_write_bloc]                              (uint32_t         )\n"));
-
-  err (_(" * nb_load_store_unit                                                                   (uint32_t         )\n"));
-  err (_(" * size_store_queue                        [nb_load_store_unit]                         (uint32_t         )\n"));
-  err (_(" * size_load_queue                         [nb_load_store_unit]                         (uint32_t         )\n"));
-  err (_(" * size_speculative_access_queue           [nb_load_store_unit]                         (uint32_t         )\n"));
-  err (_(" * nb_port_check                           [nb_load_store_unit]                         (uint32_t         )\n"));
-  err (_(" * speculative_load                        [nb_load_store_unit]                         (Tspeculative_load)\n"));
-  err (_(" * nb_bypass_memory                        [nb_load_store_unit]                         (uint32_t         )\n"));
-  err (_(" * nb_cache_port                           [nb_load_store_unit]                         (uint32_t         )\n"));
-  err (_(" * nb_inst_memory                          [nb_load_store_unit]                         (uint32_t         )\n"));
-
-  err (_(" * nb_functionnal_unit                                                                  (uint32_t         )\n"));
-  err (_(" * nb_inst_functionnal_unit                [nb_functionnal_unit]                        (uint32_t         )\n"));
-//err (_(" * timing                                  [nb_functionnal_unit][nb_type][nb_operation] (execute_timing_t )\n"));
-
-  err (_(" * nb_icache_port                                                                       (uint32_t         )\n"));
-  err (_(" * icache_port_priority                                                                 (Tpriority_t      )\n"));
-  err (_(" * icache_port_load_balancing                                                           (Tload_balancing_t)\n"));
-
-  err (_(" * nb_dcache_port                                                                       (uint32_t         )\n"));
-  err (_(" * dcache_port_priority                                                                 (Tpriority_t      )\n"));
-  err (_(" * dcache_port_load_balancing                                                           (Tload_balancing_t)\n"));
-
-  err (_(" * nb_front_end                                                                         (uint32_t         )\n"));
-  err (_(" * nb_context                              [nb_front_end]                               (uint32_t         )\n"));
-  err (_(" * nb_decod_unit                           [nb_front_end]                               (uint32_t         )\n"));
-  err (_(" * nb_inst_branch_predict                  [nb_front_end]                               (uint32_t         )\n"));
-  err (_(" * nb_inst_branch_decod                    [nb_front_end]                               (uint32_t         )\n"));
-  err (_(" * nb_inst_branch_update                   [nb_front_end]                               (uint32_t         )\n"));
-  err (_(" * btb_size_queue                          [nb_front_end]                               (uint32_t         )\n"));
-  err (_(" * btb_associativity                       [nb_front_end]                               (uint32_t         )\n"));
-  err (_(" * btb_size_counter                        [nb_front_end]                               (uint32_t         )\n"));
-  err (_(" * btb_victim_scheme                       [nb_front_end]                               (Tvictim_t        )\n"));
-  err (_(" * dir_predictor_scheme                    [nb_front_end]                               (Tpredictor_t     )\n"));
-  err (_(" * dir_have_bht                            [nb_front_end][3]                            (bool             )\n"));
-  err (_(" * dir_bht_size_shifter                    [nb_front_end][3]                            (uint32_t         )\n"));
-  err (_(" * dir_bht_nb_shifter                      [nb_front_end][3]                            (uint32_t         )\n"));
-  err (_(" * dir_have_pht                            [nb_front_end][3]                            (bool             )\n"));
-  err (_(" * dir_pht_size_counter                    [nb_front_end][3]                            (uint32_t         )\n"));
-  err (_(" * dir_pht_nb_counter                      [nb_front_end][3]                            (uint32_t         )\n"));
-  err (_(" * dir_pht_size_address_share              [nb_front_end][3]                            (uint32_t         )\n"));
-
-  err (_(" * nb_ooo_engine                                                                        (uint32_t         )\n"));
-  err (_(" * nb_rename_unit                          [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * nb_inst_issue                           [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * nb_inst_reexecute                       [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * nb_inst_commit                          [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * nb_inst_branch_complete                 [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * nb_rename_unit_select                   [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * nb_execute_loop_select                  [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * size_re_order_buffer                    [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * nb_re_order_buffer_bank                 [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * commit_priority                         [nb_ooo_engine]                              (Tpriority_t      )\n"));
-  err (_(" * commit_load_balancing                   [nb_ooo_engine]                              (Tload_balancing_t)\n"));
-  err (_(" * size_issue_queue                        [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * nb_issue_queue_bank                     [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * issue_priority                          [nb_ooo_engine]                              (Tpriority_t      )\n"));
-  err (_(" * issue_load_balancing                    [nb_ooo_engine]                              (Tload_balancing_t)\n"));
-  err (_(" * size_reexecute_queue                    [nb_ooo_engine]                              (uint32_t         )\n"));
-  err (_(" * reexecute_priority                      [nb_ooo_engine]                              (Tpriority_t      )\n"));
-  err (_(" * reexecute_load_balancing                [nb_ooo_engine]                              (Tload_balancing_t)\n"));
-
-  err (_(" * nb_execute_loop                                                                      (uint32_t         )\n"));
-  err (_(" * nb_read_unit                            [nb_execute_loop]                            (uint32_t         )\n"));
-  err (_(" * nb_execute_unit                         [nb_execute_loop]                            (uint32_t         )\n"));
-  err (_(" * nb_write_unit                           [nb_execute_loop]                            (uint32_t         )\n"));
-  err (_(" * nb_gpr_bank                             [nb_execute_loop]                            (uint32_t         )\n"));
-  err (_(" * nb_gpr_port_read_by_bank                [nb_execute_loop]                            (uint32_t         )\n"));
-  err (_(" * nb_gpr_port_write_by_bank               [nb_execute_loop]                            (uint32_t         )\n"));
-  err (_(" * nb_spr_bank                             [nb_execute_loop]                            (uint32_t         )\n"));
-  err (_(" * nb_spr_port_read_by_bank                [nb_execute_loop]                            (uint32_t         )\n"));
-  err (_(" * nb_spr_port_write_by_bank               [nb_execute_loop]                            (uint32_t         )\n"));
-  err (_(" * execution_unit_to_write_unit_priority   [nb_execute_loop]                            (Tpriority_t      )\n"));
-  err (_(" * read_unit_to_execution_unit_priority    [nb_execute_loop]                            (Tpriority_t      )\n"));
-
-  err (_(" * link_context_with_thread                [nb_thread]                                  (pair_dual        )\n"));
-  err (_(" * link_decod_unit_with_decod_bloc         [nb_decod_bloc]                              (pair_dual        )\n"));
-  err (_(" * link_rename_unit_with_rename_bloc       [nb_rename_bloc]                             (pair_dual        )\n"));
-  err (_(" * link_read_unit_with_read_bloc           [nb_read_bloc]                               (pair_dual        )\n"));
-  err (_(" * link_write_unit_with_write_bloc         [nb_write_bloc]                              (pair_dual        )\n"));
-  err (_(" * link_execute_unit_with_functionnal_unit [nb_functionnal_unit]                        (pair_dual        )\n"));
-  err (_(" * link_execute_unit_with_load_store_unit  [nb_load_store_unit]                         (pair_dual        )\n"));
-  err (_(" * link_decod_bloc_with_thread             [nb_thread]                                  (uint32_t         )\n"));
-  err (_(" * link_rename_bloc_with_front_end         [nb_front_end]                               (uint32_t         )\n"));
-  err (_(" * table_dispatch                          [nb_ooo_engine][nb_inst_issue][nb_read_bloc] (bool             )\n"));
-  err (_(" * link_read_bloc_and_load_store_unit      [nb_read_bloc][nb_load_store_unit]           (bool             )\n"));
-  err (_(" * link_read_bloc_and_functionnal_unit     [nb_read_bloc][nb_functionnal_unit]          (bool             )\n"));
-  err (_(" * link_write_bloc_and_load_store_unit     [nb_write_bloc][nb_load_store_unit]          (bool             )\n"));
-  err (_(" * link_write_bloc_and_functionnal_unit    [nb_write_bloc][nb_functionnal_unit]         (bool             )\n"));
-  err (_(" * link_load_store_unit_with_thread        [nb_thread]                                  (uint32_t         )\n"));
-  err (_(" * link_thread_and_functionnal_unit        [nb_thread][nb_functionnal_unit]             (bool             )\n"));
-  err (_(" * link_icache_port_with_thread            [nb_thread]                                  (uint32_t         )\n"));
-  err (_(" * link_dcache_port_with_load_store_unit   [nb_load_store_unit][nb_cache_port]          (uint32_t         )\n"));
-
-  err (_(" * dispatch_priority                                                                    (Tpriority_t      )\n"));
-  err (_(" * dispatch_load_balancing                                                              (Tload_balancing_t)\n"));
+  err (_(" * size_general_data                                                                    (uint32_t             )\n"));
+  err (_(" * size_special_data                                                                    (uint32_t             )\n"));
+//morpheo::behavioural::custom::custom_information_t (*get_custom_information) (void),                                  
+                                                                                                                        
+  err (_(" * nb_thread                                                                            (uint32_t             )\n"));
+  err (_(" * size_ifetch_queue                       [nb_thread]                                  (uint32_t             )\n"));
+  err (_(" * nb_inst_fetch                           [nb_thread]                                  (uint32_t             )\n"));
+//err (_(" * implement_group                         [nb_thread][NB_GROUP]                        (bool                 )\n"));
+  err (_(" * ras_size_queue                          [nb_thread]                                  (uint32_t             )\n"));
+  err (_(" * upt_size_queue                          [nb_thread]                                  (uint32_t             )\n"));
+  err (_(" * ufpt_size_queue                         [nb_thread]                                  (uint32_t             )\n"));
+                                                                                                                        
+  err (_(" * nb_decod_bloc                                                                        (uint32_t             )\n"));
+  err (_(" * size_decod_queue                        [nb_decod_bloc]                              (uint32_t             )\n"));
+  err (_(" * decod_queue_scheme                      [nb_decod_bloc]                              (Tdecod_queue_scheme_t)\n"));
+  err (_(" * nb_inst_decod                           [nb_decod_bloc]                              (uint32_t             )\n"));
+  err (_(" * nb_context_select                       [nb_decod_bloc]                              (uint32_t             )\n"));
+  err (_(" * context_select_priority                 [nb_decod_bloc]                              (Tpriority_t          )\n"));
+  err (_(" * context_select_load_balancing           [nb_decod_bloc]                              (Tload_balancing_t    )\n"));
+                                                                                                                        
+  err (_(" * nb_rename_bloc                                                                       (uint32_t             )\n"));
+  err (_(" * nb_inst_insert                          [nb_rename_bloc]                             (uint32_t             )\n"));
+  err (_(" * nb_inst_retire                          [nb_rename_bloc]                             (uint32_t             )\n"));
+  err (_(" * rename_select_priority                  [nb_rename_bloc]                             (Tpriority_t          )\n"));
+  err (_(" * rename_select_load_balancing            [nb_rename_bloc]                             (Tload_balancing_t    )\n"));
+  err (_(" * rename_select_nb_front_end_select       [nb_rename_bloc]                             (uint32_t             )\n"));
+  err (_(" * nb_general_register                     [nb_rename_bloc]                             (uint32_t             )\n"));
+  err (_(" * nb_special_register                     [nb_rename_bloc]                             (uint32_t             )\n"));
+  err (_(" * nb_reg_free                             [nb_rename_bloc]                             (uint32_t             )\n"));
+  err (_(" * nb_rename_unit_bank                     [nb_rename_bloc]                             (uint32_t             )\n"));
+  err (_(" * size_read_counter                       [nb_rename_bloc]                             (uint32_t             )\n"));
+                                                                                                                        
+  err (_(" * nb_read_bloc                                                                         (uint32_t             )\n"));
+  err (_(" * size_read_queue                         [nb_read_bloc]                               (uint32_t             )\n"));
+  err (_(" * size_reservation_station                [nb_read_bloc]                               (uint32_t             )\n"));
+  err (_(" * nb_inst_retire_reservation_station      [nb_read_bloc]                               (uint32_t             )\n"));
+                                                                                                                        
+  err (_(" * nb_write_bloc                                                                        (uint32_t             )\n"));
+  err (_(" * size_write_queue                        [nb_write_bloc]                              (uint32_t             )\n"));
+  err (_(" * size_execute_queue                      [nb_write_bloc]                              (uint32_t             )\n"));
+  err (_(" * nb_bypass_write                         [nb_write_bloc]                              (uint32_t             )\n"));
+                                                                                                                        
+  err (_(" * nb_load_store_unit                                                                   (uint32_t             )\n"));
+  err (_(" * size_store_queue                        [nb_load_store_unit]                         (uint32_t             )\n"));
+  err (_(" * size_load_queue                         [nb_load_store_unit]                         (uint32_t             )\n"));
+  err (_(" * size_speculative_access_queue           [nb_load_store_unit]                         (uint32_t             )\n"));
+  err (_(" * nb_port_check                           [nb_load_store_unit]                         (uint32_t             )\n"));
+  err (_(" * speculative_load                        [nb_load_store_unit]                         (Tspeculative_load    )\n"));
+  err (_(" * nb_bypass_memory                        [nb_load_store_unit]                         (uint32_t             )\n"));
+  err (_(" * nb_cache_port                           [nb_load_store_unit]                         (uint32_t             )\n"));
+  err (_(" * nb_inst_memory                          [nb_load_store_unit]                         (uint32_t             )\n"));
+                                                                                                                        
+  err (_(" * nb_functionnal_unit                                                                  (uint32_t             )\n"));
+  err (_(" * nb_inst_functionnal_unit                [nb_functionnal_unit]                        (uint32_t             )\n"));
+//err (_(" * timing                                  [nb_functionnal_unit][nb_type][nb_operation] (execute_timing_t     )\n"));
+                                                                                                                        
+  err (_(" * nb_icache_port                                                                       (uint32_t             )\n"));
+  err (_(" * icache_port_priority                                                                 (Tpriority_t          )\n"));
+  err (_(" * icache_port_load_balancing                                                           (Tload_balancing_t    )\n"));
+                                                                                                                        
+  err (_(" * nb_dcache_port                                                                       (uint32_t             )\n"));
+  err (_(" * dcache_port_priority                                                                 (Tpriority_t          )\n"));
+  err (_(" * dcache_port_load_balancing                                                           (Tload_balancing_t    )\n"));
+                                                                                                                        
+  err (_(" * nb_front_end                                                                         (uint32_t             )\n"));
+  err (_(" * nb_context                              [nb_front_end]                               (uint32_t             )\n"));
+  err (_(" * nb_decod_unit                           [nb_front_end]                               (uint32_t             )\n"));
+  err (_(" * nb_inst_branch_predict                  [nb_front_end]                               (uint32_t             )\n"));
+  err (_(" * nb_inst_branch_decod                    [nb_front_end]                               (uint32_t             )\n"));
+  err (_(" * nb_inst_branch_update                   [nb_front_end]                               (uint32_t             )\n"));
+  err (_(" * btb_size_queue                          [nb_front_end]                               (uint32_t             )\n"));
+  err (_(" * btb_associativity                       [nb_front_end]                               (uint32_t             )\n"));
+  err (_(" * btb_size_counter                        [nb_front_end]                               (uint32_t             )\n"));
+  err (_(" * btb_victim_scheme                       [nb_front_end]                               (Tvictim_t            )\n"));
+  err (_(" * dir_predictor_scheme                    [nb_front_end]                               (Tpredictor_t         )\n"));
+  err (_(" * dir_have_bht                            [nb_front_end][3]                            (bool                 )\n"));
+  err (_(" * dir_bht_size_shifter                    [nb_front_end][3]                            (uint32_t             )\n"));
+  err (_(" * dir_bht_nb_shifter                      [nb_front_end][3]                            (uint32_t             )\n"));
+  err (_(" * dir_have_pht                            [nb_front_end][3]                            (bool                 )\n"));
+  err (_(" * dir_pht_size_counter                    [nb_front_end][3]                            (uint32_t             )\n"));
+  err (_(" * dir_pht_nb_counter                      [nb_front_end][3]                            (uint32_t             )\n"));
+  err (_(" * dir_pht_size_address_share              [nb_front_end][3]                            (uint32_t             )\n"));
+                                                                                                                        
+  err (_(" * nb_ooo_engine                                                                        (uint32_t             )\n"));
+  err (_(" * nb_rename_unit                          [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * nb_inst_issue                           [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * nb_inst_reexecute                       [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * nb_inst_commit                          [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * nb_inst_branch_complete                 [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * nb_rename_unit_select                   [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * nb_execute_loop_select                  [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * size_re_order_buffer                    [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * nb_re_order_buffer_bank                 [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * commit_priority                         [nb_ooo_engine]                              (Tpriority_t          )\n"));
+  err (_(" * commit_load_balancing                   [nb_ooo_engine]                              (Tload_balancing_t    )\n"));
+  err (_(" * size_issue_queue                        [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * issue_queue_scheme                      [nb_ooo_engine]                              (Tissue_queue_scheme_t)\n"));
+  err (_(" * nb_issue_queue_bank                     [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * issue_priority                          [nb_ooo_engine]                              (Tpriority_t          )\n"));
+  err (_(" * issue_load_balancing                    [nb_ooo_engine]                              (Tload_balancing_t    )\n"));
+  err (_(" * size_reexecute_queue                    [nb_ooo_engine]                              (uint32_t             )\n"));
+  err (_(" * reexecute_priority                      [nb_ooo_engine]                              (Tpriority_t          )\n"));
+  err (_(" * reexecute_load_balancing                [nb_ooo_engine]                              (Tload_balancing_t    )\n"));
+                                                                                                                        
+  err (_(" * nb_execute_loop                                                                      (uint32_t             )\n"));
+  err (_(" * nb_read_unit                            [nb_execute_loop]                            (uint32_t             )\n"));
+  err (_(" * nb_execute_unit                         [nb_execute_loop]                            (uint32_t             )\n"));
+  err (_(" * nb_write_unit                           [nb_execute_loop]                            (uint32_t             )\n"));
+  err (_(" * nb_gpr_bank                             [nb_execute_loop]                            (uint32_t             )\n"));
+  err (_(" * nb_gpr_port_read_by_bank                [nb_execute_loop]                            (uint32_t             )\n"));
+  err (_(" * nb_gpr_port_write_by_bank               [nb_execute_loop]                            (uint32_t             )\n"));
+  err (_(" * nb_spr_bank                             [nb_execute_loop]                            (uint32_t             )\n"));
+  err (_(" * nb_spr_port_read_by_bank                [nb_execute_loop]                            (uint32_t             )\n"));
+  err (_(" * nb_spr_port_write_by_bank               [nb_execute_loop]                            (uint32_t             )\n"));
+  err (_(" * execution_unit_to_write_unit_priority   [nb_execute_loop]                            (Tpriority_t          )\n"));
+  err (_(" * read_unit_to_execution_unit_priority    [nb_execute_loop]                            (Tpriority_t          )\n"));
+                                                                                                                        
+  err (_(" * link_context_with_thread                [nb_thread]                                  (pair_dual            )\n"));
+  err (_(" * link_decod_unit_with_decod_bloc         [nb_decod_bloc]                              (pair_dual            )\n"));
+  err (_(" * link_rename_unit_with_rename_bloc       [nb_rename_bloc]                             (pair_dual            )\n"));
+  err (_(" * link_read_unit_with_read_bloc           [nb_read_bloc]                               (pair_dual            )\n"));
+  err (_(" * link_write_unit_with_write_bloc         [nb_write_bloc]                              (pair_dual            )\n"));
+  err (_(" * link_execute_unit_with_functionnal_unit [nb_functionnal_unit]                        (pair_dual            )\n"));
+  err (_(" * link_execute_unit_with_load_store_unit  [nb_load_store_unit]                         (pair_dual            )\n"));
+  err (_(" * link_decod_bloc_with_thread             [nb_thread]                                  (uint32_t             )\n"));
+  err (_(" * link_rename_bloc_with_front_end         [nb_front_end]                               (uint32_t             )\n"));
+  err (_(" * table_dispatch                          [nb_ooo_engine][nb_inst_issue][nb_read_bloc] (bool                 )\n"));
+  err (_(" * link_read_bloc_and_load_store_unit      [nb_read_bloc][nb_load_store_unit]           (bool                 )\n"));
+  err (_(" * link_read_bloc_and_functionnal_unit     [nb_read_bloc][nb_functionnal_unit]          (bool                 )\n"));
+  err (_(" * link_write_bloc_and_load_store_unit     [nb_write_bloc][nb_load_store_unit]          (bool                 )\n"));
+  err (_(" * link_write_bloc_and_functionnal_unit    [nb_write_bloc][nb_functionnal_unit]         (bool                 )\n"));
+  err (_(" * link_load_store_unit_with_thread        [nb_thread]                                  (uint32_t             )\n"));
+  err (_(" * link_thread_and_functionnal_unit        [nb_thread][nb_functionnal_unit]             (bool                 )\n"));
+  err (_(" * link_icache_port_with_thread            [nb_thread]                                  (uint32_t             )\n"));
+  err (_(" * link_dcache_port_with_load_store_unit   [nb_load_store_unit][nb_cache_port]          (uint32_t             )\n"));
+                                                                                                                        
+  err (_(" * dispatch_priority                                                                    (Tpriority_t          )\n"));
+  err (_(" * dispatch_load_balancing                                                              (Tload_balancing_t    )\n"));
   err (_("\n"));
   err (_(" - pair_dual : first = x div 1000, second = x mod 1000\n"));
@@ -189,4 +191,6 @@
   uint32_t                _nb_decod_bloc                                 ;//
   uint32_t              * _size_decod_queue                              ;//[nb_decod_bloc]
+  multi_front_end::front_end::decod_unit::decod_queue::Tdecod_queue_scheme_t
+                        * _decod_queue_scheme                            ;//[nb_decod_bloc]
   uint32_t              * _nb_inst_decod                                 ;//[nb_decod_bloc]
   uint32_t              * _nb_context_select                             ;//[nb_decod_bloc]
@@ -281,4 +285,6 @@
   Tload_balancing_t     * _commit_load_balancing                         ;//[nb_ooo_engine]
   uint32_t              * _size_issue_queue                              ;//[nb_ooo_engine]
+  multi_ooo_engine::ooo_engine::issue_queue::Tissue_queue_scheme_t
+                        * _issue_queue_scheme                            ;//[nb_ooo_engine]
   uint32_t              * _nb_issue_queue_bank                           ;//[nb_ooo_engine]
   Tpriority_t           * _issue_priority                                ;//[nb_ooo_engine]
@@ -354,8 +360,9 @@
   SELFTEST0(_nb_decod_bloc                                 ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+6*_nb_decod_bloc))
     usage (argc, argv);
   
   SELFTEST1(_size_decod_queue                              ,uint32_t                ,argv,x,_nb_decod_bloc);
+  SELFTEST1(_decod_queue_scheme                            ,multi_front_end::front_end::decod_unit::decod_queue::Tdecod_queue_scheme_t,argv,x,_nb_decod_bloc);
   SELFTEST1(_nb_inst_decod                                 ,uint32_t                ,argv,x,_nb_decod_bloc);
   SELFTEST1(_nb_context_select                             ,uint32_t                ,argv,x,_nb_decod_bloc);
@@ -367,5 +374,5 @@
   SELFTEST0(_nb_rename_bloc                                ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+6*_nb_decod_bloc+10*_nb_rename_bloc))
     usage (argc, argv);
   
@@ -385,5 +392,5 @@
   SELFTEST0(_nb_read_bloc                                  ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+6*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc))
     usage (argc, argv);
   
@@ -396,5 +403,5 @@
   SELFTEST0(_nb_write_bloc                                 ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+6*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc))
     usage (argc, argv);
   
@@ -407,5 +414,5 @@
   SELFTEST0(_nb_load_store_unit                            ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+6*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit))
     usage (argc, argv);
   
@@ -424,5 +431,5 @@
   SELFTEST0(_nb_functionnal_unit                           ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+6*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit))
     usage (argc, argv);
   
@@ -467,5 +474,5 @@
   SELFTEST0(_nb_front_end                                  ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+6*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end))
     usage (argc, argv);
   
@@ -494,5 +501,5 @@
   SELFTEST0(_nb_ooo_engine                                 ,uint32_t                ,argv,x);
   
-  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+6*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end+19*_nb_ooo_engine))
     usage (argc, argv);
   
@@ -509,4 +516,5 @@
   SELFTEST1(_commit_load_balancing                         ,Tload_balancing_t       ,argv,x,_nb_ooo_engine);
   SELFTEST1(_size_issue_queue                              ,uint32_t                ,argv,x,_nb_ooo_engine);
+  SELFTEST1(_issue_queue_scheme                            ,multi_ooo_engine::ooo_engine::issue_queue::Tissue_queue_scheme_t,argv,x,_nb_ooo_engine);
   SELFTEST1(_nb_issue_queue_bank                           ,uint32_t                ,argv,x,_nb_ooo_engine);
   SELFTEST1(_issue_priority                                ,Tpriority_t             ,argv,x,_nb_ooo_engine);
@@ -521,5 +529,5 @@
   SELFTEST0(_nb_execute_loop                               ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine+11*_nb_execute_loop))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+6*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end+19*_nb_ooo_engine+11*_nb_execute_loop))
     usage (argc, argv);
   
@@ -539,5 +547,5 @@
   printf(" * Link\n");
 
-  if (argc < static_cast<int>(2+NB_PARAMS+6*_nb_thread+6*_nb_decod_bloc+11*_nb_rename_bloc+4*_nb_read_bloc+4*_nb_write_bloc+9*_nb_load_store_unit+2*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine+11*_nb_execute_loop))
+  if (argc < static_cast<int>(2+NB_PARAMS+6*_nb_thread+6*_nb_decod_bloc+11*_nb_rename_bloc+4*_nb_read_bloc+4*_nb_write_bloc+9*_nb_load_store_unit+2*_nb_functionnal_unit+31*_nb_front_end+19*_nb_ooo_engine+11*_nb_execute_loop))
     usage (argc, argv);
   
@@ -593,5 +601,5 @@
     _sum_cache_port += _nb_cache_port[i];
   
-  if (argc != static_cast<int>(2+NB_PARAMS+6*_nb_thread+6*_nb_decod_bloc+11*_nb_rename_bloc+4*_nb_read_bloc+4*_nb_write_bloc+9*_nb_load_store_unit+2*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine+11*_nb_execute_loop+
+  if (argc != static_cast<int>(2+NB_PARAMS+6*_nb_thread+6*_nb_decod_bloc+11*_nb_rename_bloc+4*_nb_read_bloc+4*_nb_write_bloc+9*_nb_load_store_unit+2*_nb_functionnal_unit+31*_nb_front_end+19*_nb_ooo_engine+11*_nb_execute_loop+
                                3*_nb_thread+_nb_front_end+_sum_inst_issue*_nb_read_bloc+_nb_load_store_unit*(_nb_read_bloc+_nb_write_bloc+_nb_thread)+_nb_functionnal_unit*(_nb_read_bloc+_nb_write_bloc)+_sum_cache_port))
     usage (argc, argv);
@@ -633,4 +641,5 @@
          _nb_decod_bloc                                 ,
          _size_decod_queue                              ,
+         _decod_queue_scheme                            ,
          _nb_inst_decod                                 ,
          _nb_context_select                             ,
@@ -714,4 +723,5 @@
          _commit_load_balancing                         ,
          _size_issue_queue                              ,
+         _issue_queue_scheme                            ,
          _nb_issue_queue_bank                           ,
          _issue_priority                                ,
